/*
 * BCC2GRX  -  Interfacing Borland based graphics programs to LIBGRX
 * Copyright (C) 1993-96 by Hartmut Schirmer
 *
 * This library is copyrighted (see above). It might be used and
 * distributed freely as long as all copyright notices are left
 * intact.
 *
 * You may not distribute any changed versions of BCC2GRX without
 * written permission by Hartmut Schirmer.
 *
 * You are permitted to distribute an application linked with BCC2GRX
 * in binary only, provided that the documentation of the program:
 *
 *    a)   informs the user that BCC2GRX is used in the program, AND
 *
 *    b)   provides the user with the necessary information about
 *         how to obtain BCC2GRX. (i.e. ftp site, etc..)
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Contact :                Hartmut Schirmer
 *                          Feldstrasse 118
 *                  D-24105 Kiel
 *                          Germany
 *
 * e-mail : hsc@techfak.uni-kiel.d400.de
 */

#include "bccgrx00.h"

char *getdrivername( void )
{
  _DO_INIT_CHECK_RV(NULL);
#ifdef GRX_VERSION
{
  static char *grxname = NULL;
  const GrVideoDriver *vd = GrCurrentVideoDriver();
  if (vd != NULL) {
    grxname = realloc(grxname, 16+strlen(vd->name));
    if (grxname != NULL) {
      strcpy(grxname, "GRX driver \"");
      strcat(grxname, vd->name);
      strcat(grxname, "\"");
      return grxname;
    }
  }
}
#else
  switch (__gr_ADAPTER) {
    case GR_VGA         : return "VGA driver";
    case GR_EGA         : return "EGA driver";
    case GR_HERC        : return "Hercules mono driver";
    case GR_8514A       : return "8514A driver";
    case GR_S3          : return "S3 graphics accelerator driver";
  }
#endif
  return "unknown graphics driver";
}

